﻿using System;
using Windows.Foundation.Collections;

namespace VSLiveWinRTData
{
    /// <summary>
    /// Event args for WinRT list based controls that listen to collection changes
    /// </summary>
    public class VectorChangedEventArgs : IVectorChangedEventArgs
    {
        /// <summary>
        /// New instance of the args
        /// </summary>
        /// <param name="collectionChange">Type of change</param>
        /// <param name="index">Index at which change occurred</param>
        public VectorChangedEventArgs(CollectionChange collectionChange, uint index)
        {
            CollectionChange = collectionChange;
            Index = index;
        }

        /// <summary>
        /// Type of change
        /// </summary>
        public CollectionChange CollectionChange { get; private set; }

        /// <summary>
        /// Index at which change occurred
        /// </summary>
        public uint Index { get; private set; }

    }
}
