﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Threading;
using System.Web.Http;
using System.Web.Http.ModelBinding;
using System.Web.Http.ValueProviders;
using WinRT.Data;

namespace WinRTWeb.Controllers
{
    public class SessionsController : ApiController
    {

        // GET /api/sessions
        public IEnumerable<Session> Get()
        {
            using (var context = new Context())
            {
                context.Configuration.LazyLoadingEnabled = false;
                context.Configuration.ProxyCreationEnabled = false;
                return context.Sessions.ToArray();
            }
        }

        public HttpResponseMessage Post(Session session)
        {
            UpdateSessionDate(session);
            if (ModelState.IsValid)
            {
                using (var context = new Context())
                {
                    context.Sessions.Add(session);
                    context.SaveChanges();
                }
                return Request.CreateResponse(System.Net.HttpStatusCode.Created, session);
            }
            else
            {
                return Request.CreateResponse(System.Net.HttpStatusCode.BadRequest, session);
            }
        }

        public HttpResponseMessage Put(Session session)
        {
            UpdateSessionDate(session);
            if (ModelState.IsValid)
            {
                using (var context = new Context())
                {
                    context.Entry(session).State = System.Data.EntityState.Modified;
                    context.SaveChanges();
                }
                return Request.CreateResponse(System.Net.HttpStatusCode.OK, session);
            }
            else
            {
                return Request.CreateResponse(System.Net.HttpStatusCode.BadRequest, session);
            }
        }

        public HttpResponseMessage Delete(int id)
        {
            using (var context = new Context())
            {
                var session = new Session { SessionID = id };
                context.Entry(session).State = System.Data.EntityState.Deleted;
                context.SaveChanges();
            }
            return new HttpResponseMessage(HttpStatusCode.NoContent);
        }

        private void UpdateSessionDate(Session session)
        {
            //if (ModelState.ContainsKey("When") && ModelState["When"].Value.AttemptedValue.Contains("Date"))
            //{
            //    session.When = DateConverter.Convert(ModelState["When"].Value.AttemptedValue);
            //    ModelState.Remove("When");
            //    ModelState.Add("When", new ModelState());
            //    ModelState.SetModelValue("When", new ValueProviderResult(session.When, session.When.ToString(), Thread.CurrentThread.CurrentCulture));
            //}
        }
    }
}